; Centripod
; ported to the Plus/4 by Ulrich Hecht <ulrich.hecht@gmail.com>

; system time
TimeByte2 = $A5 ; check

; keyboard input
LstxCurrentKeyPressed = $7f6 ; check
XmaxSizeOfKeyboardBuf = $53f ; check
ShflagShiftFlags = $543 ; check

; generic memory, can be put anywhere
BufSystemInputBuffer = $3C00 ; this is only used +$aa, i.e. to address L2AA etc.
L2AA = $3CAA
L2AB = $3CAB
L2AE = $3CAE
L2AF = $3CAF
L2B0 = $3CB0
L2B1 = $3CB1
L2BF = $3CBF
L2C0 = $3CC0
L2CC = $3CCC
L2CD = $3CCD
L2CE = $3CCE
L2CF = $3CCF
L2D0 = $3CD0
L2F0 = $3CF0
L2F1 = $3CF1
L2FF = $3CFF

; video matrix
VideoMatrixBase = $c00 ; check
VideoMatrix100h = $d00 ; check
L5B8 = $dB8 ; check
L5D0 = $dD0 ; check
VideoMatrix200h = $e00 ; check
VideoMatrix300h = $f00 ; check

; generic memory, can be put anywhere
L5000 = $3d00
L5001 = $3d01
L5040 = $3d40
L50A0 = $3dA0

; video control registers
;VICMemoryControlReg = $D018
TEDReg12h = $ff12
TEDReg13h = $ff13
VICBorderColor = $ff19 ; check
VICBGColor0 = $ff15 ; check

; SID registers
SIDVoc1FreqLowByte = $FD40
SIDVoc1FreqHiByte = $FD41
SIDVoc1ControlReg = $FD44
SIDEnv1AttackDecay = $FD45
SIDEnv1SustainRelease = $FD46
SIDVoc2FreqHiByte = $FD48
SIDVoc2ControlReg = $FD4B
SIDEnv2AttackDecay = $FD4C
SIDEnv2SustainRelease = $FD4D
SIDVoc3FreqHiByte = $FD4F
SIDVoc3ControlReg = $FD52
SIDEnv3AttackDecay = $FD53
SIDEnv3SustainRelease = $FD54
SIDFilterVolume = $FD58
SIDMirrorD500 = $2100
SIDMirrorD600 = $2200
SIDMirrorD700 = $2300
TEDReg0fh = $ff0f	; voice 2 freq low byte
TEDReg11h = $ff11	; sound control register

; color memory
ColorRAM = $800 ;check
ColorRAM28h = $828 ; check
ColorRAM100h = $900 ; check
ColorRAM200h = $A00 ; check
ColorRAM300h = $B00 ; check
ColorRAM348h = $B48 ; check

; joystick
;Joy2 = $DC00
TEDJoystick = $ff08

; timer
CIA1TimerALow = $ff00 ; check
CIA1TimerALowMir = $ff00 ; check

; kernal routines
ChrOut = $FFD2 ; check (same on all C=s)
GetIn = $FFE4 ; check (same on all C=s)

	ORG $1001-2
	DW  $1001
	
	DW $100B,0
	DB $9E,"4112",0,0,0
        DB 0,0,0
        
L810:
  LDA #$93
  JSR LA00
  LDA #$0 ; black
  STA VICBGColor0
  STA VICBorderColor ; check (black is the same on C64 and P4)
  LDX #$0
L81F:
  LDA L2A00,X
  STA VideoMatrixBase,X
  LDA L2B00,X
  STA VideoMatrix100h,X
  LDA L2C00,X
  STA VideoMatrix200h,X
  LDA L2D00,X
  STA VideoMatrix300h,X
  INX
  CPX #$0
  BNE L81F
L83C:
  LDA #$71 ; check (white is 1 on C64, $71 on P4)
  LDX #$0
L840:
  STA ColorRAM,X
  STA ColorRAM100h,X
  STA ColorRAM200h,X
  STA ColorRAM300h,X
  INX
  CPX #$0
  BNE L840
L851:
  JSR L1230
  JSR L1600
  LDA #$1
  STA L1621
  JSR L1620
  NOP
  LDA #$0
  LDX #$AA
L864:
  STA BufSystemInputBuffer,X
  INX
  CPX #$0
  BNE L864
L86C:
  JSR L1700
  NOP
L870:
  JSR L1800
  LDA L18FF
  CMP #$0
  BEQ L88D
L87A:
  LDA L2B0
  CMP #$0
  BNE L88D
L881:
  LDX L2AB
  LDY L2AA
  STX L2B1
  JSR LA20
L88D:
  LDA #$0
  JSR LA60
  LDA L18FE
  CMP #$0
  BEQ L8F3
L899:
  LDY L2AA
  LDX L2AB
  JSR L1850
  JMP L8B3
  DB $0,$0,$0
  DB $0,$0,$0
L8AB:
  ;LDA #$15
  ;STA VICMemoryControlReg ; restore std video mode
  LDA #$d0
  STA TEDReg13h
  LDA #$c4
  STA TEDReg12h
  JMP L810
L8B3:
  STY L2AE
  STX L2AF
  JSR L1500
  JSR L1535
  CMP #$20
  BEQ L8D9
L8C3:
  CMP #$2
  BEQ L8D6
L8C7:
  CMP #$3
  BEQ L8D6
L8CB:
  CMP #$4
  BEQ L8D6
L8CF:
  CMP #$5
  BEQ L8D6
L8D3:
  JMP L2000
L8D6:
  JMP L8F3
L8D9:
  LDY L2AA
  LDX L2AB
  JSR L1500
  LDA #$20
  JSR L153A
  LDY L2AE
  LDX L2AF
  STY L2AA
  STX L2AB
L8F3:
  LDY L2AA
  LDX L2AB
  JSR L1500
  LDA #$0
  JSR L153A
  LDA L153C
  ;CLC
  ; ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  ; player sprite color (red)
  ; LDA #$2 ; C64
  LDA #$32 ; P4
  JSR L153A
  LDA LstxCurrentKeyPressed
  CMP #$2A
  BEQ L8AB
L915:
  LDA #$0
  STA L18FE
  JSR L1680
  JSR L1F00
  JSR L1F00
  JSR L1680
  JSR L930
  JMP L944
L92D = * + 1
  DB $0,$2,$0
  DB $0
L930:
  INC L92D
  LDA L92D
L937 = * + 1
; Instruction parameter accessed. (seems to be OK, not a pointer)
  CMP #$7
  BNE L942
L93A:
  LDA #$0
  STA L92D
  JMP L1000
L942:
  RTS
  DB $60
L944:
  JSR L970
  JSR L1F00
  LDY L2AA
  LDX L2AB
  JSR L1500
  JSR L1535
  CMP #$0
  BEQ L95D
L95A:
  JMP L963
L95D:
  JSR L2830
  JMP L870
L963:
  CMP #$20
  BEQ L95D
L967:
  JMP L200B
  DB $0,$0,$0
  DB $0,$0,$0
L970:
  JSR L1F00
  JSR L2500
  JSR L2600
  JSR L2530
  JSR L2660
  RTS
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0
LA00:
  JSR ChrOut
  LDX #$00
  TXA
LA06:
  STA SIDVoc1FreqLowByte,X
  STA SIDMirrorD500,X
  STA SIDMirrorD600,X
  STA SIDMirrorD700,X
  INX
  CPX #$19
  BNE LA06
  STA TEDReg11h	; turn off all sound generators
LA17:
  LDA #$F
  STA SIDFilterVolume
  LDA #$f	; disable generators 1/2, full volume
  STA TEDReg11h
  JMP LAB0
  DB $60
LA20:
  STY L2B0
  LDA #$C0
  STA SIDEnv1AttackDecay
  LDA #$FA
  STA SIDEnv1SustainRelease
  LDA #$11	; triangle waveform, start attack/decay/sustain
  STA SIDVoc1ControlReg
  LDA #$70
  STA LA3F
  STA SIDVoc1FreqHiByte
LA3A:
  RTS
LA3B:
  DW $1150	; this is made a jump target by overwriting the RTS at LA3A
LA3D:
  RTS
LA3F = * + 1
  DB $60,$70 
LA40:
  NOP
  NOP
  NOP
  DEC LA3F
  DEC LA3F
  DEC LA3F
  DEC LA3F
  LDA LA3F
  STA SIDVoc1FreqHiByte
  RTS
temp1:
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60,$60
LA5F:
  RTS
LA60:
  STA L18FF
  LDA L2B0
  CMP #$0
  BNE LA5F
LA6A:
  LDA #$0
  RTS
LA70:
  LDA #$40
  STA SIDEnv1AttackDecay
  LDA #$FA
  STA SIDEnv1SustainRelease
  LDA #$2
  STA SIDVoc1FreqHiByte
  LDA #$81	; noise on, start att/dec/sus
  STA SIDVoc1ControlReg

  ; p4 version
  LDA TEDReg12h
  AND #$fc	; clear voice 2 freq bits 8,9
  STA TEDReg12h
  LDA #$8
  STA TEDReg0fh	; voice 2 freq bits 0-7
  LDA TEDReg11h
  AND #$9f	; turn off voice 2
  ORA #$40	; turn on voice 2 noise
  STA TEDReg11h
  
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60
LA90:
  LDX #$0
LA92:
  INX
  CPX #$0
  BNE LA92
LA97:
  LDA #$80	; noise, start release
  STA SIDVoc1ControlReg
  
  ; p4 version
  ; i guess this maps to turn off voice 2
  LDA TEDReg11h
  AND #$9f
  STA TEDReg11h
  
  RTS
  DB $60,$60,$60
LAA0:
  JSR LA70
  LDX #$0
  RTS
  DB $60,$60,$60
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0
LAB0:
  LDA #$0
  STA L2D0
  LDA #$8
  STA L937
  LDA #$0
  STA L25F0
  STA L25F1
  STA L25FA
  STA L25FB
  STA L28F0
  STA L28F1
  STA L28F2
  LDA #$30
  STA L1691
  JSR L1300
  LDA #$8
  JMP ChrOut
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
LB00 = * + 1
  DB $0,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $E9,$A0,$A0
  DB $DF,$20,$E9
  DB $A0,$A0,$DF
  DB $20,$DF,$E9
  DB $DF,$E9,$DF
  DB $20,$A0,$A0
  DB $A0,$20,$20
  DB $20,$20,$E9
  DB $A0,$DF,$20
  DB $A0,$20,$A0
  DB $20,$A0,$A0
  DB $A0,$20,$A0
  DB $A0,$DF,$20
  DB $20,$A0,$20
  DB $20,$20,$20
  DB $A0,$20,$20
  DB $A0,$20,$A0
  DB $20,$A0,$20
  DB $A0,$20,$A0
  DB $62,$20,$20
  DB $20,$20,$20
  DB $A0,$20,$A0
  DB $20,$A0,$20
  DB $A0,$20,$A0
  DB $62,$20,$20
  DB $A0,$20,$A0
  DB $20,$20,$A0
  DB $20,$20,$FB
  DB $20,$A0,$A0
  DB $A0,$A0,$20
  DB $A0,$20,$A0
  DB $20,$A0,$20
  DB $A0,$E2,$20
  DB $20,$20,$20
  DB $20,$A0,$20
  DB $A0,$20,$A0
  DB $20,$A0,$20
  DB $A0,$E2,$20
  DB $20,$A0,$A0
  DB $69,$20,$20
  DB $5F,$A0,$A0
  DB $69,$20,$A0
  DB $20,$20,$A0
  DB $20,$A0,$20
  DB $A0,$20,$A0
  DB $20,$A0,$A0
  DB $A0,$20,$20
  DB $20,$20,$5F
  DB $A0,$69,$20
  DB $5F,$A0,$69
  DB $20,$A0,$A0
  DB $A0,$20,$A0
  DB $20,$FC,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
LC00 = * + 2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $70,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
LD00:
  DB $40,$40,$40
  DB $40,$6E,$20
  DB $20,$20,$20
  DB $20,$5D,$14
  DB $F,$20,$10
  DB $C,$1,$19
  DB $20,$1,$7
  DB $1,$9,$E
  DB $20,$10,$12
  DB $5,$13,$13
  DB $20,$14,$8
  DB $5,$20,$13
  DB $10,$1,$3
  DB $5,$20,$2
  DB $1,$12,$5D
  DB $20,$20,$20
  DB $20,$20,$6D
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $7D,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $70,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $6E,$20,$20
  DB $20,$5D,$1
  DB $20,$7,$1
  DB $D,$5,$20
  DB $2,$19,$3A
  DB $20,$20,$14
  DB $8,$5,$20
  DB $13,$F,$6
  DB $14,$17,$1
  DB $12,$5,$20
  DB $17,$8,$9
  DB $1A,$20,$B
  DB $9,$4,$13
  DB $2E,$5D,$20
  DB $20,$20,$6D
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$7D
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
LE00 = * + 1
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$0
  DB $FF,$F3,$F7
  DB $70,$FF,$0
  DB $FB,$F7,$FF
  DB $FF,$FF,$0
  DB $FF,$F7,$FF
  DB $0,$FF,$F3
  DB $FF,$0,$FF
  DB $F7,$FF,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
LF9A:
  CPY #$A
  BMI LFD2
LF9E:
  INC L50A0
  LDA L50A0
  CMP #$A
  BNE LFD2
LFA8:
  LDX #$0
LFAA:
  STX L2FF
  LDY L5000,X
  LDA L5001,X
  TAX
  JSR L1500
  LDY L2FF
  LDA L5000,Y
  CMP #$AA
  BEQ LFC6
LFC1:
  LDA #$2
  JSR LFDA
LFC6:
  LDX L2FF
  INX
  INX
  CPX #$1A
  BNE LFAA
LFCF:
  JMP L1016
LFD2:
  JMP L101C
  DB $0,$0,$0
  DB $0,$0
LFDA:
  LDY #$0
  JSR L153A
  LDA L153C
  ;CLC
  ; ADC #$D4 offset video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  ; mushroom color (green)
  ; LDA #$5 ; C64
  LDA #$45 ; P4
  JMP L153A
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0
L1000:
  LDX #$0
  LDY #$0
L1004:
  LDA L5000,X
  CMP #$AA
  BNE L100C
L100B:
  INY
L100C:
  INX
  INX
  CPX #$1A
  BNE L1004
L1012:
  CPY #$D
  BNE LF9A
L1016:
  JSR L1741
  JMP L1880
L101C:
  LDX #$0
L101E:
  STX L2FF
  JMP L10E0
L1024:
  STA L10FE
  LDA L5001,X
  STA L10FF
  TAX
  LDY L10FE
  JSR L1500
  JSR L1535
  STA L10FD
  LDX L2FF
  LDA L5040,X
  STA L10FC
  LDX #$0
  LDA #$20
  JSR L153A
  LDA L10FC
  CMP #$0
  BEQ L1064
L1051:
  LDA L10FF
  CMP #$0
  BEQ L105E
L1058:
  DEC L10FF
  JMP L1074
L105E:
  JSR L1100
  JMP L1074
L1064:
  LDA L10FF
  CMP #$27
  BEQ L1071
L106B:
  INC L10FF
  JMP L1074
L1071:
  JSR L1100
L1074:
  LDY L10FE
  LDX L10FF
  JSR L1500
  JSR L1535
  CMP #$20
  BEQ L1090
L1084:
  CMP L10FD
  BEQ L1090
L1089:
  CMP #$0
  BEQ L1090
L108D:
  JMP L1C00
L1090:
  LDX L2FF
  LDA L10FC
  STA L5040,X
  LDA L10FE
  STA L5000,X
  LDA L10FF
  STA L5001,X
L10A5:
  LDX L2FF
  INX
  INX
  CPX #$1A
  BEQ L10B1
L10AE:
  JMP L101E
L10B1:
  JSR L1760
  LDX #$0
  LDA L10D0
  CMP #$0
  BNE L10BE
L10BD:
  INX
L10BE:
  STX L10D0
  JSR L1760
  JSR L1330
  JMP L2830
  DB $0,$0,$0
  DB $0,$0,$0
L10D0:
  DB $1,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0
L10E0:
  LDA L5000,X
  CMP #$AA
  BEQ L10A5
L10E7:
  JMP L1024
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
L10FC:
L10FD = * + 1
L10FE = * + 2
  DB $0,$6,$0
L10FF:
  DB $1B
L1100:
  LDA L10FC
  CMP #$0
  BNE L110D
L1107:
  INC L10FC
  JMP L1110
L110D:
  DEC L10FC
L1110:
  INC L10FE
  LDA L10FE
  CMP #$18
  BNE L1127
L111A:
  LDA #$0
  STA L10FF
  STA L10FC
  LDA #$5
  STA L10FE
L1127:
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60
L1130:
  LDA LstxCurrentKeyPressed
  CMP #$4	; key 'F1'
  BNE L1140
L1136:
  LDA #$4C
  STA LA3A
L113B:
  RTS
  DB $60,$60,$60
  DB $60
L1140:
  CMP #$5	; key 'F3'
  BNE L113B
L1144:
  LDA #$60
  STA LA3A
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
L1150:
  LDA #$81	; noise, start att/dec/sus
  STA SIDVoc1ControlReg
  
  ; p4 version
  ; turn on noise
  LDA TEDReg11h
  AND #$9f
  ORA #$40
  STA TEDReg11h
  
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$52
L1200:
  LDX #$0
L1202:
  LDA L2C0,X
  CMP L12A0,X
  BEQ L1214
L120A:
  CMP L12A0,X
  BMI L1230
L120F:
  CMP L12A0
  BPL L121A
L1214:
  INX
  CPX #$10
  BNE L1202
L1219:
  RTS
L121A:
  LDX #$0
L121C:
  LDA L2C0,X
  STA L12A0,X
  INX
  CPX #$10
  BNE L121C
L1227:
  JMP L1230
  DB $60,$60,$60
  DB $60,$60,$60
L1230:
  LDX #$0
L1232:
  LDA L12C0,X
  STA VideoMatrixBase,X
  ; LDA #$1 white on C64
  LDA #$71 ; white on P4
  STA ColorRAM,X
  INX
  CPX #$16
  BNE L1232
L1242:
  LDX #$0
L1244:
  LDA L12A0,X
  CMP #$0
  BNE L1250
L124B:
  INX
  CPX #$E
  BNE L1244
L1250:
  LDY #$B
L1252:
  LDA L12A0,X
  CLC
  ADC #$30
  STA VideoMatrixBase,Y
  TXA
  ORA #$70 ; full luminance
  STA ColorRAM,Y
  INY
  INX
  CPX #$10
  BNE L1252
L1265:
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
L12A0 = * + 1
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $3,$2,$2
  DB $9,$7,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
L12C0:
  DB $8,$9,$7
  DB $8,$20,$13
  DB $3,$F,$12
  DB $5,$3A,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0
L1300:
  LDA #$C0
  STA SIDEnv3AttackDecay
  LDA #$FA
  STA SIDEnv3SustainRelease
  LDA #$11	; triangle, start att/dec/sus
  STA SIDVoc3ControlReg
  LDA #$0
  STA SIDVoc3FreqHiByte
  LDA #$40
  STA SIDEnv2AttackDecay
  LDA #$FA
  STA SIDEnv2SustainRelease
  LDA #$11	; triangle, start att/dec/sus
  STA SIDVoc2ControlReg
  LDA #$0
  STA SIDVoc2FreqHiByte
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60
L1330:
  LDA L10D0
  CMP #$0
  BEQ L1339
L1337:
  LDA #$5
L1339:
  STA SIDVoc2FreqHiByte
  RTS
  DB $60,$60,$60
L1340:
  LDA L10D0
  CLC
  ADC #$5
  STA SIDVoc3FreqHiByte
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
L1350:
  LDA #$0
  STA SIDVoc2FreqHiByte
  STA SIDVoc3FreqHiByte
  LDY L2AA
  RTS
  DB $60,$60,$60
  DB $60
L1360:
  LDA L18FE
  CMP #$0
  BNE L1394
L1367:
  LDY #$0
  LDX #$0
  LDA LstxCurrentKeyPressed
  CMP #$E
  BNE L1373
L1371:
  LDY #$1
L1373:
  CMP #$17
  BNE L1379
L1377:
  LDY #$2
L1379:
  CMP #$A	; key 'A'
  BNE L137F
L137D:
  LDY #$3
L137F:
  CMP #$12	; key 'D'
  BNE L1385
L1383:
  LDY #$4
L1385:
  STY L18FE
  LDA ShflagShiftFlags
  CMP #$0
  BEQ L139A
L138F:
  LDA #$1
  STA L18FF
L1394:
  LDY #$0
  LDX #$0
  LDA #$0
L139A:
  RTS
  DB $60,$60,$60
  DB $60,$60,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
L1500:
  ;LDA #$4 looks like the video matrix hi byte
  LDA #$c
L1502:
  STA L2F0
  STX L2F1
L1508:
  CPY #$0
  BEQ L151E
L150C:
  DEY
  LDA L2F1
  CLC
  ADC #$28 ; check (screen width, same on C64 and P4)
  STA L2F1
  BCC L1508
L1518:
  INC L2F0
  JMP L1508
L151E:
  LDA L2F0
  STA L1537
  STA L153C
  LDA L2F1
  STA L1536
  STA L153B
  LDX #$0
  RTS
  DB $60,$60
L1535:
L1536 = * + 1
; Instruction parameter accessed.
L1537 = * + 2
; Instruction parameter accessed.
  LDA ColorRAM348h,X
  RTS
  DB $60
L153A:
L153B = * + 1
; Instruction parameter accessed.
L153C = * + 2
; Instruction parameter accessed.
  STA ColorRAM348h,X
  RTS
  DB $60,$60,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$2,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $2,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$2,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0
L1600:
  STX L161E
  STY L161F
  LDX #$0
L1608:
  LDY #$0
L160A:
  INY
  CPY #$0
  BNE L160A
L160F:
  INX
  CPX #$0
  BNE L1608
L1614:
  LDX L161E
  LDY L161F
  RTS
  DB $60,$60,$60
L161E:
L161F = * + 1
  DB $28,$16
L1620:
L1621 = * + 1
  LDA #$A ; C64
  STA L16FF
  LDA #$0
  STA L2AA
L162A:
  INC L2AA
  LDY L2AA
L1631 = * + 1
; Instruction parameter accessed. (should be OK, not a vector)
  CPY #$16
  BEQ L165A
L1634:
  LDX #$0
  LDA #$08	; check (color RAM start hi byte)
  JSR L1502
  LDA L16FF
  LDX #$0
L1640:
  ORA #$60 ; P4 luminance (don't want to use a lookup table just for this effect)
  JSR L153A
  INX
  CPX #$28
  BNE L1640
L1648:
  INC L16FF
  LDA L16FF
  CMP #$10 ; top color cycle limit C64
  BNE L1657
L1652:
  LDA #$1 ; C64 white
  STA L16FF
L1657:
  JMP L162A
L165A:
  JSR GetIn
  CMP #$20
  BEQ L16A0
L1661:
  JSR L1680
  INC L1621
  LDA L1621
  CMP #$10
  BNE L1673
L166E:
  LDA #$1
  STA L1621
L1673:
  JMP L1620
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0
L1680:
  STX L161E
  STY L161F
  LDX #$0
L1688:
  LDY #$0
L168A:
  INY
  CPY #$30
  BNE L168A
L168F:
  INX
L1691 = * + 1
; Instruction parameter accessed. (should be OK, not a vector)
  CPX #$30
  BNE L1688
L1694:
  LDX L161E
  LDY L161F
  RTS
  DB $60,$60,$60
  DB $60,$60
L16A0:
  LDA #$93
  JMP ChrOut
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$2
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $2,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
L16FF:
  ; DB $1 C64 white
  DB $71 ; P4 white
L1700:
  ;LDA #$1C
  ;STA VICMemoryControlReg ; load custom charset
  LDA #$38
  STA TEDReg13h
  LDA #$c0
  STA TEDReg12h
  ; mushroom color (green)
  ; LDA #$5 C64
  LDA #$45 ; P4
  LDX #$0
L1709:
  STA ColorRAM28h,X
  STA ColorRAM100h,X
  STA ColorRAM200h,X
  STA ColorRAM300h,X
  INX
  CPX #$0
  BNE L1709

; the game assumes that the first line in color RAM already contains a
; suitable value ($e). This is true on the C64, but not on the P4
  LDA #$6d	; light blue
  LDX #$28
lightblueloop:
  STA ColorRAM,x
  DEX
  BNE lightblueloop
  LDX #$0

L171A:
  LDA L2100,X
  STA VideoMatrixBase,X
  LDA L2200,X
  STA VideoMatrix100h,X
  LDA L2300,X
  STA VideoMatrix200h,X
  LDA L2400,X
  STA VideoMatrix300h,X
  INX
  CPX #$0
  BNE L171A
L1737:
  LDA #$17
  STA L2AA
  LDA #$13
  STA L2AB
L1741:
  LDA #$0
  TAX
L1744:
  STA L5000,X
  INX
  CPX #$0
  BNE L1744
L174C:
  LDA #$0
L174E:
  STA L5001,X
  CLC
  ADC #$1
  INX
  INX
  CPX #$22
  BNE L174E
L175A:
  RTS
  DB $60,$60,$60
  DB $60,$60
L1760:
  LDX #$0
L1762:
  STX L2FF
  JMP L17D0
L1768:
  LDA L5001,X
  TAX
  JSR L17C5
  LDY L5040,X
  CPY #$0
  BNE L177B
L1776:
  LDA #$6
  JMP L177D
L177B:
  LDA #$8
L177D:
  CLC
  ADC L10D0
  JSR L17B5
  LDX L2FF
  LDA L5000,X
  CMP #$0
  BEQ L179E
L178E:
  LDA L153C
  ;CLC
  ; ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  ; blue
  ; LDA #$6 C64
  LDA #$36 ; P4
  LDX #$0
  JSR L153A
L179E:
  LDX L2FF
  INX
  INX
  CPX #$1A
  BNE L1762
L17A7:
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60
L17B0:
; Instruction opcode accessed. (huh? where?)
  LDX #$0
  JMP L1535
L17B5:
  LDX #$0
  JMP L153A
L17BA:
  JSR L17B0
  STA L17CF
  LDA #$20
  JMP L17B5
L17C5:
  JSR L1500
  LDX L2FF
  RTS
  DB $60,$60,$60
L17CF:
  DB $8
L17D0:
  LDY L5000,X
  CPY #$AA
  BEQ L179E
L17D7:
  JMP L1768
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0
L1800:
  LDA #$1
  JSR L1840
  LDY #$0
  LDX #$0
  CMP #$7F
  BEQ L1837
L180D:
  CMP #$70
  BPL L1815
L1811:
  CLC
  ADC #$10
  INY
L1815:
  CMP #$77
  BNE L181B
L1819:
  LDX #$4
L181B:
  CMP #$7B
  BNE L1821
L181F:
  LDX #$3
L1821:
  CMP #$7D
  BNE L1827
L1825:
  LDX #$2
L1827:
  CMP #$7E
  BNE L182D
L182B:
  LDX #$1
L182D:
  STX L18FE
  STY L18FF
  LDX #$0
  LDY #$0
L1837:
  JMP L1360
  DB $60,$60,$60
  DB $60,$60,$60
L1840:
  STA XmaxSizeOfKeyboardBuf
  JSR L1130
  ; LDA Joy2
  ; read P4 joystick 2 data and convert it to c64 format
  LDA #$fd	; select joystick 2
  STA TEDJoystick
  LDA TEDJoystick	; read joystick data
  ; directions are the same on both platforms, but the
  ; fire button of joystick 2 is bit 4 on c64, bit 7 on p4
  CMP #$80
  BCS nobutton
  AND #$f
  ORA #$60
  RTS
nobutton:
  AND #$f
  ORA #$70
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
L1850:
  CMP #$1
  BNE L1859
L1854:
  CPY #$10
  BEQ L1859
L1858:
  DEY
L1859:
  CMP #$2
  BNE L1862
L185D:
  CPY #$17
  BEQ L1862
L1861:
  INY
L1862:
  CMP #$3
  BNE L186B
L1866:
  CPX #$0
  BEQ L186B
L186A:
  DEX
L186B:
  CMP #$4
  BNE L1874
L186F:
  CPX #$27
  BEQ L1874
L1873:
  INX
L1874:
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60
L1880:
  LDA L937
  CMP #$1
  BEQ L188A
L1887:
  DEC L937
L188A:
  LDA L937
  CMP #$1
  BNE L189B
L1891:
  LDA L1631
  CMP #$1
  BEQ L189B
L1898:
  DEC L1631
L189B:
  RTS
  DB $60,$60,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
L18FE = * + 2
  DB $0,$0,$2
L18FF:
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0
L1C00:
  CMP #$0
  BEQ L1C24
L1C04:
  CMP #$9
  BEQ L1C27
L1C08:
  CMP #$6
  BEQ L1C27
L1C0C:
  CMP #$7
  BEQ L1C27
L1C10:
  CMP #$8
  BEQ L1C27
L1C14:
  CMP #$2
  BEQ L1C2A
L1C18:
  CMP #$3
  BEQ L1C2A
L1C1C:
  CMP #$4
  BEQ L1C2A
L1C20:
  CMP #$5
  BEQ L1C2A
L1C24:
  JMP L1C2D
L1C27:
  JMP L1090
L1C2A:
  JMP L1CA0
L1C2D:
  CMP #$1
  BEQ L1C3D
L1C31:
  CMP #$C
  BEQ L1C3D
L1C35:
  CMP #$D
  BEQ L1C3D
L1C39:
  JMP L1C2A
  DB $0
L1C3D:
  JMP L1CFA
L1C40:
  LDA L28F2
  CMP #$2
  BEQ L1C56
L1C47:
  CMP #$3
  BEQ L1C56
L1C4B:
  CMP #$4
  BEQ L1C56
L1C4F:
  CMP #$5
  BEQ L1C56
L1C53:
  JMP L1C5C
L1C56:
  STA L28FA
  JMP L1C61
L1C5C:
  LDA #$20
  STA L28FA
L1C61:
  LDY L28F0
  LDX L28F1
  JSR L1500
  LDA L28FA
  JSR L153A
  LDA L153C
  ;CLC
  ; ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  ; mushroom color (green)
  ; LDA #$5 C64
  LDA #$45 ; P4
  JSR L153A
  LDA #$0
  STA L28F0
  STA L28F1
  STA L28F2
  INC L2CC
  JSR L1E03
  INC L2CC
  JSR L1E03
  LDA #$0
  STA L2B0
  STA SIDVoc3FreqHiByte
  RTS
  DB $60,$60
L1CA0:
  LDA L1537
  ;CLC
  ; ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L1537
  JSR L1535
L1CAC:
  SEC
  SBC #$10
  BCS L1CAC
L1CB1:
  CLC
  ADC #$10
  CMP #$5
  BEQ L1CFA
L1CB8:
  JMP LFA8
L1CBB:
  LDY L5000,X
  LDA L5001,X
  TAX
  JSR L1500
  LDA #$2
  JSR L153A
  LDX L2FF
  LDA #$AA
  STA L5000,X
  STA L5001,X
  JMP L10A5
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0
L1CFA:
  JSR L1100
  JMP L1051
L1D00:
  CMP #$0
  BEQ L1D27
L1D04:
  CMP #$6
  BEQ L1D18
L1D08:
  CMP #$7
  BEQ L1D18
L1D0C:
  CMP #$8
  BEQ L1D18
L1D10:
  CMP #$9
  BEQ L1D18
L1D14:
  JMP L1D80
  DB $0
L1D18:
  JMP L1D2A
L1D1B:
  NOP
  NOP
  NOP
  NOP
  NOP
  NOP
  NOP
  NOP
  NOP
  NOP
  NOP
  NOP
L1D27:
  JMP L1090
L1D2A:
  LDX #$0
L1D2C:
  LDA L5000,X
  CMP L2B0
  BEQ L1D37
L1D34:
  JMP L1D3F
L1D37:
  LDA L5001,X
  CMP L2B1
  BEQ L1D50
L1D3F:
  INX
  INX
  CPX #$1A
  BNE L1D2C
L1D45:
  LDA #$0
  STA L2B0
  RTS
  DB $60,$60
L1D4D:
  JSR LA70
L1D50:
  LDA #$AA
  STA L5000,X
  LDX #$0
  LDA #$2
  JSR L153A
  LDA L153C
  ;CLC
  ; ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  ; mushroom color (green)
  ; LDA #$5 C64
  LDA #$45 ; P4
  JSR L153A
  LDY #$0
L1D6C:
  INC L2CE
  JSR L1E03
  INY
  CPY #$5
  BNE L1D6C
L1D77:
  LDA #$0
  STA L2B0
  RTS
  DB $60,$60,$60
L1D80:
  CMP #$C
  BNE L1DA0
L1D84:
  LDY L25F0
  LDX L25F1
  JSR L1500
  LDA #$2
  JSR L153A
  INC L2CC
  JSR L1E03
  LDA #$0
  STA L25F0
  RTS
  DB $60,$60
L1DA0:
  CMP #$D
  BNE L1DC0
L1DA4:
  LDY L25FA
  LDX L25FB
  JSR L1500
  LDA #$2
  JSR L153A
  INC L2CD
  JSR L1E03
  LDA #$0
  STA L25FB
  RTS
  DB $60,$60
L1DC0:
  CMP #$B
  BEQ L1DD0
L1DC4:
  CMP #$A
  BEQ L1DD0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0
L1DD0:
  JMP L1C40
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
L1DE9 = * + 1
  DB $0,$13,$3
  DB $F,$12,$5
  DB $20,$6,$F
  DB $12,$20,$14
  DB $8,$9,$13
  DB $20,$7,$1
  DB $D,$5,$20
  DB $9,$13,$3A
L1E00:
  INC L2CF
L1E03:
  LDX #$F
L1E05:
  LDA L2C0,X
  CMP #$A
  BNE L1E14
L1E0C:
  LDA #$0
  STA L2C0,X
  INC L2BF,X
L1E14:
  DEX
  CPX #$FF
  BNE L1E05
L1E19:
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0
L1F00:
  LDY L2B0
  CPY #$0
  BNE L1F08
L1F07:
  RTS
L1F08:
  LDX L2B1
  JSR L1500
  LDA #$20
  JSR L153A
  DEC L2B0
  LDA L2B0
  CMP #$0
  BEQ L1F07
L1F1D:
  LDY L2B0
  LDX L2B1
  JSR L1500
  JSR L1535
  CMP #$2
  BEQ L1F80
L1F2D:
  CMP #$3
  BEQ L1F80
L1F31:
  CMP #$4
  BEQ L1F80
L1F35:
  CMP #$5
  BEQ L1F80
L1F39:
  CMP #$20
  BEQ L1F40
L1F3D:
  JMP L1D00
L1F40:
  LDY L2B0
  LDX L2B1
  JSR L1500
  LDA #$1
  JSR L153A
  LDA L153C
  ;CLC
  ; ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  ; purple
  ; LDA #$4 C64
  LDA #$44 ; P4
  JSR L153A
  JMP LA40
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
L1F80:
  CLC
  ADC #$1
  CMP #$6
  BNE L1F89
L1F87:
  LDA #$20
L1F89:
  JSR L153A
  JSR L1E00
  LDA #$0
  STA L2B0
  RTS
  DB $60,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0
L2000:
  CMP #$0
  BNE L2007
L2004:
  JMP L8D9
L2007:
  CMP #$1
  BEQ L2004
L200B:
  JSR L1350
  LDX L2AB
  JSR L20E0
  LDA #$0
  STA L20FF
L2019:
  LDY #$E
  JSR LAA0
L201E:
  TYA
  JSR L153A
  LDA L153C
  ;CLC
  ; ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  TYA
  CLC
  ORA #$70
  JSR L20F0
  LDA L153C
  ;SEC
  ;SBC #$D4 offset from video matrix to color ram
  CLC
  ADC #$4
  STA L153C
  INY
  CPY #$16
  BNE L201E
L203D:
  JSR LA97
  INC L20FF
  LDA L20FF
  CMP #$FF
  BNE L2019
L204A:
  JSR LA90
  LDA #$20
  JSR L153A
  INC L2D0
  LDA L2D0
  CMP #$4
  BNE L205F
L205C:
  JMP L2090
L205F:
  LDX #$0
L2061:
  STX L2FF
  LDY L5000,X
  LDA L5001,X
  TAX
  JSR L1500
  JSR L1535
  CMP #$20
  BEQ L207A
L2075:
  LDA #$20
  JSR L153A
L207A:
  LDX L2FF
  INX
  INX
  CPX #$1A
  BNE L2061
L2083:
  JSR L1737
  JSR L2900
  JMP L870
  DB $0,$0,$0
  DB $0
L2090:
  ;LDA #$15
  ;STA VICMemoryControlReg ; normal video mode
  LDA #$d0
  STA TEDReg13h
  LDA #$c4
  STA TEDReg12h
  LDA #$93
  JSR ChrOut
  LDX #$0
L209C:
  LDA L1DE9,X
  STA L5B8,X
  INX
  CPX #$17
  BNE L209C
L20A7:
  LDX #$0
  LDY #$0
L20AB:
  LDA L2C0,X
  CMP #$0
  BNE L20B7
L20B2:
  INX
  CPX #$E
  BNE L20AB
L20B7:
  LDA L2C0,X
  CLC
  ADC #$30
  STA L5D0,Y
  INX
  INY
  CPX #$10
  BNE L20B7
L20C6:
  ; red
  ; LDA #$2 C64
  LDA #$32 ; P4
  LDX #$B8
L20CA:
  STA ColorRAM100h,X
  INX
  CPX #$0
  BNE L20CA
L20D2:
  ;LDA #$15
  ;STA VICMemoryControlReg
  LDA #$d0
  STA TEDReg13h
  LDA #$c4
  STA TEDReg12h
  LDA #$8
  JSR ChrOut
  JMP L2E00
  DB $0
L20E0:
  JSR L1500
  LDA #$0
  STA SIDVoc1FreqHiByte
  STA SIDVoc1FreqHiByte
  RTS
  DB $60,$60,$60
  DB $60
L20F0:
  JSR L153A
  LDX #$0
L20F5:
  INX
  CPX #$0
  BNE L20F5
L20FA:
  RTS
  DB $60,$60,$60
L20FF = * + 1
L2100 = * + 2
  DB $60,$FF,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$2
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$2,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
L2200:
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $2,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$2,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $2,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$2
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$2,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$2
  DB $20,$2,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $2,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $2,$20,$20
L2300 = * + 1
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$2,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$2
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$2
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $2,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$2,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
L2400 = * + 2
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$2,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$2,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $2,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $0,$FF,$F3
  DB $F7,$70,$FF
  DB $0,$FB,$F7
  DB $FF,$FF,$FF
  DB $0,$FF,$F7
  DB $FF,$0,$FF
  DB $F3,$FF,$0
  DB $FF,$F7,$FF
L2500:
  LDA L25F0
  CMP #$0
  BEQ L2508
L2507:
  RTS
L2508:
  LDA CIA1TimerALow
L250B:
  SEC
  SBC #$28
  BCS L250B
L2510:
  CLC
  ADC #$28
  CMP #$12
  BNE L2507
L2517:
  LDA TimeByte2
L2519:
  SEC
  SBC #$28
  BCS L2519
L251E:
  CLC
  ADC #$28
  STA L25F1
  LDA #$1
  STA L25F0
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
L2530:
  LDA L25FB
  CMP #$0
  BEQ L2538
L2537:
  RTS
L2538:
  LDA CIA1TimerALow
L253B:
  SEC
  SBC #$28
  BCS L253B
L2540:
  CLC
  ADC #$28
  CMP #$14
  BNE L2537
L2547:
  LDA TimeByte2
L2549:
  SEC
  SBC #$16
  BCS L2549
L254E:
  CLC
  ADC #$17
  STA L25FA
  LDA #$1
  STA L25FB
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
L2560:
  LDY L25F0
  CPY #$0
  BNE L2568
L2567:
  RTS
L2568:
  LDX L25F1
  JSR L1500
  JSR L1535
  JSR L2700
  JSR L153A
  INC L25F0
  LDA L153C
  ;CLC
  ; ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  ; mushroom color (green)
  ; LDA #$5 C64
  LDA #$45 ; P4
  JSR L153A
  LDA L25F0
  CMP #$18
  BNE L2595
L258F:
  LDA #$0
  STA L25F0
  RTS
L2595:
  LDY L25F0
  LDX L25F1
  JSR L1500
  LDA #$C
  JSR L153A
  LDA L153C
  ;CLC
  ;ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  ; brown
  ; LDA #$9 C64
  LDA #$29 ; P4
  JSR L153A
  RTS
  DB $60,$60,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
L25F0 = * + 2
  DB $0,$0,$0
L25F1:
  DB $23,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
L25FA:
L25FB = * + 1
  DB $B,$0,$0
  DB $0,$0,$0
L2600:
  LDX L25FB
  CPX #$0
  BNE L2608
L2607:
  RTS
L2608:
  LDY L25FA
  JSR L1500
  JSR L1535
  JSR L2700
  JSR L153A
  INC L25FB
  LDA L153C
  ;CLC
  ;ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  ; mushroom color (green)
  ; LDA #$5 C64
  LDA #$45 ; P4
  JSR L153A
  LDA L25FB
  CMP #$28
  BNE L2635
L262F:
  LDA #$0
  STA L25FB
  RTS
L2635:
  LDY L25FA
  LDX L25FB
  JSR L1500
  LDA #$D
  JSR L153A
  LDA L153C
  ;CLC
  ;ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  ; LDA #$7 C64
  LDA #$77
  JSR L153A
  RTS
  DB $60,$60,$8D
  DB $FB,$25
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
L265F = * + 1
  DB $60,$1
L2660:
  INC L265F
  LDA L265F
  CMP #$2
  BNE L2672
L266A:
  LDA #$0
  STA L265F
  JMP L2560
L2672:
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
L2700:
  LDA CIA1TimerALowMir
L2703:
  SEC
  SBC #$20
  BCS L2703
L2708:
  CLC
  ADC #$20
  CMP #$1A
  BPL L2712
L270F:
  LDA #$20
  RTS
L2712:
  LDA #$2
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0
L2800:
  LDA L28F0
  CMP #$0
  BEQ L2808
L2807:
  RTS
L2808:
  LDA CIA1TimerALow
L280B:
  SEC
  SBC #$28
  BCS L280B
L2810:
  CLC
  ADC #$28
  CMP #$F
  BNE L2807
L2817:
  LDA TimeByte2
L2819:
  SEC
  SBC #$4
  BCS L2819
L281E:
  CLC
  ADC #$17
  STA L28F0
  LDA #$27
  STA L28F1
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
L2830:
  JSR L2800
  LDA L28F0
  CMP #$0
  BNE L283B
L283A:
  RTS
L283B:
  LDA L28F2
  CMP #$2
  BEQ L2851
L2842:
  CMP #$3
  BEQ L2851
L2846:
  CMP #$4
  BEQ L2851
L284A:
  CMP #$5
  BEQ L2851
L284E:
  JMP L2857
L2851:
  STA L28FA
  JMP L285C
L2857:
  LDA #$20
  JMP L2851
L285C:
  LDY L28F0
  LDX L28F1
  JSR L1500
  LDA L28FA
  JSR L153A
  LDA L153C
  ;CLC
  ;ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  ; mushroom color (green)
  ; LDA #$5 C64
  LDA #$45 ; P4
  JSR L153A
  LDY L28F0
  LDX L28F1
  LDA L28F8
  CMP #$0
  BEQ L288E
L2886:
  INY
  CPY #$19
  BNE L288F
L288B:
  DEC L28F8
L288E:
  DEY
L288F:
  CPY #$F
  BNE L2897
L2893:
  INC L28F8
  INY
L2897:
  STY L28F0
  JSR L2700
  CMP #$2
  BNE L28A2
L28A1:
  INX
L28A2:
  DEX
  CPX #$FF
  BNE L28B4
L28A7:
  LDA #$0
  STA L28F0
  STA L28F1
  JMP L28DD
  DB $60,$60
L28B4:
  STX L28F1
  LDY L28F0
  JSR L1500
  JSR L1535
  STA L28F2
  LDA #$A
  CLC
  ADC L10D0
  JSR L153A
  LDA L153C
  ;CLC
  ; ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  ; dark grey
  ; LDA #$B C64
  LDA #$31 ; P4
  JSR L153A
  JMP L1340
L28DD:
  STA L28F2
  STA SIDVoc3FreqHiByte
  RTS
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60,$60
  DB $60,$60
L28F0 = * + 1
  DW L1760
L28F1:
L28F2 = * + 1
  DW L2019
  DB $0,$0,$0
L28F8 = * + 2
  DB $0,$0,$0
L28FA = * + 1
  DB $0,$20,$0
  DB $0,$0,$0
  DB $0
L2900:
  LDA L28F2
  CMP #$2
  BEQ L2916
L2907:
  CMP #$3
  BEQ L2916
L290B:
  CMP #$4
  BEQ L2916
L290F:
  CMP #$5
  BEQ L2916
L2913:
  JMP L291C
L2916:
  STA L28FA
  JMP L2921
L291C:
  LDA #$20
  STA L28FA
L2921:
  LDY L28F0
  LDX L28F1
  JSR L1500
  LDA L28FA
  JSR L153A
  LDA L153C
  ;CLC
  ; ADC #$D4 offset from video matrix to color ram
  SEC
  SBC #$4
  STA L153C
  ; mushroom color (green)
  ; LDA #$5 C64
  LDA #$45 ; P4
  JSR L153A
  LDA #$0
  STA L28F0
  STA L28F1
  STA L28F2
  LDY L25F0
  LDX L25F1
  JSR L1500
  LDA #$0
  STA L25F0
  STA L25F1
  LDA #$20
  JSR L153A
  LDY L25FA
  LDX L25FB
  JSR L1500
  LDA #$0
  STA L25FA
  STA L25FB
  LDA #$20
  JSR L153A
  RTS
  DB $60,$60,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
L2A00:
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$6C
  DB $A0,$A0,$7B
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$6C
  DB $A0,$A0,$A0
  DB $A0,$7B,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$6C
  DB $A0,$A0,$7E
  DB $20,$7C,$A0
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$6C
  DB $A0,$A0,$7E
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $A0,$A0,$7E
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
L2B00 = * + 1
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$A0,$A0
  DB $7B,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$7C
  DB $A0,$A0,$7B
  DB $20,$20,$20
  DB $20,$20,$FE
  DB $A0,$EC,$20
  DB $A0,$7B,$20
  DB $A0,$20,$A0
  DB $A0,$A0,$20
  DB $A0,$A0,$7B
  DB $7C,$A0,$7E
  DB $A0,$A0,$7B
  DB $20,$FE,$A0
  DB $FC,$20,$A0
  DB $A0,$7B,$20
  DB $20,$7C,$A0
  DB $A0,$7B,$20
  DB $6C,$A0,$20
  DB $A0,$62,$20
  DB $20,$A0,$A0
  DB $7B,$A0,$20
  DB $20,$A0,$20
  DB $20,$A0,$20
  DB $A0,$20,$A0
  DB $20,$A0,$20
  DB $A0,$20,$A0
  DB $20,$A0,$20
  DB $A0,$20,$A0
  DB $20,$20,$20
  DB $7C,$A0,$A0
  DB $A0,$A0,$7E
  DB $20,$A0,$E2
  DB $20,$20,$A0
  DB $7C,$A0,$A0
  DB $20,$20,$A0
  DB $20,$20,$A0
  DB $A0,$7E,$20
  DB $A0,$20,$A0
  DB $A0,$7E,$20
  DB $A0,$20,$A0
  DB $20,$A0,$20
  DB $A0,$20,$20
  DB $20,$20,$7C
  DB $A0,$A0,$7E
  DB $20,$20,$FB
  DB $A0,$FC,$20
  DB $A0,$20,$7C
  DB $A0,$20,$20
  DB $A0,$20,$20
  DB $A0,$20,$FC
  DB $6C,$A0,$7B
  DB $A0,$20,$20
  DB $20,$FB,$A0
  DB $EC,$20,$A0
  DB $A0,$7E,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
L2C00 = * + 2
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $70,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$6E,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$5D,$10
  DB $12,$5,$13
  DB $13,$20,$14
  DB $8,$5,$20
  DB $93,$90,$81
  DB $83,$85,$20
  DB $14,$F,$20
  DB $13,$14,$1
  DB $12,$14,$20
  DB $7,$1,$D
  DB $5,$2E,$5D
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$6D
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $40,$40,$40
  DB $7D,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
L2D00:
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$20,$20
  DB $20,$0,$FF
  DB $F3,$F7,$70
  DB $FF,$0,$FB
  DB $F7,$FF,$FF
  DB $FF,$0,$FF
  DB $F7,$FF,$0
  DB $FF,$F3,$FF
  DB $0,$FF,$F7
  DB $FF
L2E00:
  JSR L1200
  JSR L1600
  JSR L1600
  JSR L1600
  JSR L1600
  JSR L1600
  JSR L1600
  LDA #$93
  JSR ChrOut
  LDX #$0
L2E1C:
  LDA LB00,X
  STA VideoMatrixBase,X
  LDA LC00,X
  STA VideoMatrix100h,X
  LDA LD00,X
  STA VideoMatrix200h,X
  LDA LE00,X
  STA VideoMatrix300h,X
  ; LDA #$1 white on C64
  LDA #$71 ; white on P4
  STA ColorRAM,X
  STA ColorRAM100h,X
  STA ColorRAM200h,X
  STA ColorRAM300h,X
  INX
  CPX #$0
  BNE L2E1C
L2E47:
  LDA #$1
  STA L1621
  JSR L1230
  JSR L1620
  JMP L810

	ORG $3800
CustomCharSet:
  DB $18,$3C
  DB $5A,$FF,$7E
  DB $3C,$18,$18
  DB $8,$10,$8
  DB $10,$8,$10
  DB $8,$10,$18
  DB $7E,$FF,$3F
  DB $18,$1C,$3E
  DB $7F,$18,$7E
  DB $FF,$1F,$18
  DB $1C,$0,$0
  DB $18,$7E,$FF
  DB $F,$0,$0
  DB $0,$0,$18
  DB $7E,$0,$0
  DB $0,$0,$0
  DB $0,$24,$7E
  DB $EA,$FE,$C6
  DB $7C,$44,$66
  DB $24,$7E,$EA
  DB $FE,$C6,$7C
  DB $88,$CC,$24
  DB $7E,$57,$7F
  DB $63,$3E,$22
  DB $66,$24,$7E
  DB $57,$7F,$63
  DB $3E,$11,$33
  DB $42,$24,$5A
  DB $3C,$7E,$42
  DB $24,$0,$24
  DB $24,$5A,$3C
  DB $7E,$81,$42
  DB $24,$3C,$5A
  DB $3C,$42,$3C
  DB $66,$42,$81
  DB $6,$1D,$32
  DB $98,$8C,$46
  DB $7F,$3E,$81
  DB $42,$24,$18
  DB $18,$24,$42
  DB $81,$81,$42
  DB $24,$0,$0
  DB $24,$42,$81
  DB $81,$42,$0
  DB $0,$0,$0
  DB $42,$81,$81
  DB $0,$0,$0
  DB $0,$0,$0
  DB $81,$10,$10
  DB $10,$1F,$F8
  DB $8,$8,$8
  DB $10,$10,$10
  DB $7,$E0,$8
  DB $8,$8,$10
  DB $10,$0,$3
  DB $C0,$0,$8
  DB $8,$10,$0
  DB $0,$1,$80
  DB $0,$0,$8
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0,$0,$0
  DB $0
